import SwiftUI

struct TodoCard: View {
    var todo: Todo

    var body: some View {
        HStack {
            VStack(alignment: .leading) {
                Text(todo.title)
                    .font(.title).fontWeight(.semibold)
                HStack {
                    Image(systemName: "clock")
                    Text(formatter.string(from: todo.dueDate))
                }
                    .foregroundColor(Color.gray).font(.headline)
                    .padding(.leading, 8)
            }
            Spacer()
        }
        .padding().background(Color.white)
        .cornerRadius(6).shadow(radius: 3)
    }
}

private let formatter: DateFormatter = {
    let formatter = DateFormatter()
    formatter.dateFormat = "M月d日"
    return formatter
}()

struct TodoCard_Previews: PreviewProvider {
    static var previews: some View {
        Group {
            ZStack {
                Color(white: 0.9)
                TodoCard(todo: Todo(title: "1行のタイトル", dueDate: Date(timeIntervalSince1970: 43252532422)))
            }
            .previewLayout(.fixed(width: 320, height: 150))

            ZStack {
                Color(white: 0.9)
                TodoCard(todo: Todo(title: "2行のタイトル2行のタイトル", dueDate: Date(timeIntervalSince1970: 222442342342)))
            }
            .previewLayout(.fixed(width: 320, height: 150))
        }
    }
}
